function [x, i] = golden(f, a, b, tol)
i = 1;
R = (sqrt(5)-1)/2;
x1 = b - R*(b-a);
x2 = a + R*(b-a);
f1 = f(x1); f2 = f(x2);
 
while abs(x2-x1)>tol 
  if f1 < f2
     b = x2;
     x2 = x1; f2 = f1; % taken from previous iteration
     x1 = b - R*(b-a);
     f1 = f(x1);  % this must be evaluated   
  else
     a = x1;
     x1 = x2; f1 = f2; % taken from previous iteration
     x2 = a + R*(b-a);
     f2 = f(x2);  % this must be evaluated   
  end
  i = i+1;
end  
x = (x1+x2)/2;